; http://www.ybnet.fr.st - email: yb_net@yahoo.fr
; Logiciel de communication de bas niveau.
; protocole logiciel: 175bps, 1 start, 1 stop, pas de parit.
; (UART logiciel). 
; Registre en sortie: mise a 1 du bit <=> mise a 0 de la ligne
; Registre en entre: 1 correspond  un niveau bas, 0  un niveau haut.
; attribution des broches: fil rouge=sortie(bit #0), 
;			   fil blanc/jaune=entre(bit #3).
; version 1.08 pour TI92 Fargo v0.7.2.1
; 
; bug: no bug known

 	include "tios.h"	
 	include "flib.h"
 	include "hexlib.h"
 	include "macros.h"    ; Macros utilises par le programme
 	xdef _main
 	xdef _comment

WriteStrA MACRO
 move.w  \3,-(a7)
 move.l  \4,-(a7)
 move.w  \2,-(a7)
 move.w  \1,-(a7)
 jsr     tios::DrawStrXY
 lea     10(a7),a7
 ENDM



_main:
				; regarde s'il y a 1000 octets de libre
	move.l  #1000,-(a7)		
 	jsr     tios::HeapAlloc		
 	lea     4(a7),a7		
 	cmp     #0,d0
 	beq     OutOfMem
 	move.w  d0,hnum
 	tios::DEREF d0,a0
	move.l  a0,hptr
	
		
        jsr 	flib::clr_scr       ; efface l'ecran
        SetFont #1		; fonte systeme=1
	bsr screen_put		; on affiche les gri-gris
 
	clr.b $60000C		; initialisation du registre de linking
        bset.b #6,$60000C       ; active le mode de controle direct
        bclr.b #0,$60000E      	; sortie rouge=1(rouge/)
        bclr.b #1,$60000E	; sortie blanche=1(blanche/)
	 			; rem: blanc=entree...
	
	WriteStr #1,#113,#4,request
contact:
	
	move.b	#23,d5		; demande de connection au reseau
	bsr	send

	move.b	#50,d4
waiting0:				; boucle d'attente reponse hote avec
	move.w	(tios::kb_vars+$1E),d0   ;possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)	; scrute 49 fois avant de relancer une requete
	cmp.w	#264,d0
	beq	abort
	btst.b	#3,$60000E	; attente d'1 bit de start	
	bne	yahoo
	dbra	d4,waiting0
	bra	contact	; pas de reponse, a repart pour un tour
	
yahoo:
	
	

	bsr 	rcv
	cmp.b	#129,d5
	beq	connect_ok
	bne	abort
	
connect_ok:			; connection a l'hote etabli
	jsr 	flib::clr_scr 
	move.w	#240,d4
line1:				; on trace la ligne de separation horizontale
	move.w 	#111,-(a7)	; Coordonne y
	move.w 	d4,-(a7) 	; Coordonne x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line1
	
	move.w	#240,d4
line2:				; on trace la ligne de separation horizontale
	move.w 	#9,-(a7)	; Coordonne y
	move.w 	d4,-(a7) 	; Coordonne x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line2

	move.w	#9,d4
line3:				; on trace la petite ligne de separation verticale
	move.w 	d4,-(a7)	; Coordonne y
	move.w 	#180,-(a7) 	; Coordonne x
	jsr 	flib::pixel_on
	lea 	4(a7),a7
	dbra	d4,line3

	pea	connected(PC)	; on affiche les messages en bas
	jsr	tios::ST_showHelp
	lea	4(a7),a7

	
	move.b	#6,d5
	bsr	send
		
	
waiting2:			; boucle d'attente d'un octet avec possibilit d'aborter
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort
	btst.b	#3,$60000E	; attente d'1 bit de start	
	beq	waiting2

	bsr	rcv		; on reoit le nom des utilisateurs
	bsr	show_user	; on affiche les noms d'utisateurs 
				; connects(D0=channel1,...,D4)
	
	WriteStr #185,#1,#4,titre3
	move.w	#13,index
	move.b	#1,line

main_loop:
	movem.l d0-d4/a0-a6,-(a7)
	pea	standby(PC)	; on attend l'entre du texte ou d'une commande
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

				; ici commence la boucle de communication
	WriteStr #1,#113,#4,space2
	WriteStr #1,#113,#4,user
	
				; on rentre le texte
	lea     str(PC),a1	; on met un caractere de depart
	movem.l d0-d3,-(a7)
 	move.w	#0,d4
 	move.w	#113,d1		; postion y du texte
 	move.w	#37,d3		; postion x du texte
	move.w	#33,d6		; nombre de caracteres maxi retournable
	bra 	Input		; d4 reoit le nombre de caracteres retourns
suitxt:
	lea     str(PC),a1	; on met un caractere de fin
	lea     0(a1),a2	; on transfere dans a2
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	connecting(PC)	; on demande une emission de donnes
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

	move.b	d4,d6		; on met le nombre de caracteres  envoyer dans d6
contacting:
	move.b	#129,d5		; envoi d'une requete
	bsr	send

	move.b	#50,d4
waiting3:				; boucle d'attente reponse hote avec
	move.w	(tios::kb_vars+$1E),d0   ;possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)	; scrute 51 fois avant de relancer une requete
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; attente d'1 bit de start	
	bne	reponse
	dbra	d4,waiting3
	bra	contacting	; pas de reponse, a repart pour un tour
	
reponse:
	bsr	rcv
	cmp.b	#6,d5
	bne	abort2

	movem.l d0-d4/a0-a6,-(a7)
	pea	connected(PC)	; on est connect a l'hote
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6

				; on envoi la longueur du message
	move.b	d6,d5		; longueur du packet
	bsr	send
	tst.b	d6		; si la longueur est nulle :touche="enter"
	beq	refresh

	
waiting4:			; boucle d'attente d'un octet avec possibilit d'aborter
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; attente d'1 bit de start	
	beq	waiting4


	bsr	rcv
	cmp.b	#6,d5
	bne	abort2
	
	movem.l d0-d4/a0-a6,-(a7)
	pea	transmitting(PC) ; on envoit le packet
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	
				
loop:
				; on envoi le message
	move.b	(a1)+,d5	; packet=message
	bsr	send
	move.w	(tios::kb_vars+$1E),d0 ; on  laisse la possibilit d'aborter
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	dbra	d6,loop

	bsr	delay3		; fin du packet
	move.b	#56,d5
	bsr	send

refresh:
	movem.l d0-d4/a0-a6,-(a7)
	pea	waiting_(PC) 		; on attend la mise  jour de la fenetre...
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6
	
	bsr	delay3
	move.b	line,d5		; on envoi la position courante de la ligne
	bsr	send

waiting5:			; boucle d'attente d'un octet avec possibilit d'aborter
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	btst.b	#3,$60000E	; attente d'1 bit de start	
	beq	waiting5

	bsr	rcv		; on attend le debut du packet de retour...
	cmp.b	#129,d5
	bne	abort2
		
	movem.l d0-d4/a0-a6,-(a7)
	pea	receiving(PC) 		; on reoit la mise  jour de la fenetre...
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	movem.l (a7)+,d0-d4/a0-a6	
	
	bsr	rcv	
	bsr	show_user	; on affiche les noms d'utisateurs 
				; connects(D0=channel1,...,D4)
	
	move.b	#6,d5		
	bsr	send		; on previent que c ok

loop2:
	
	bsr	rcv
	cmp.b	#56,d5		; 56=rien de nouveau
	beq	main_loop
	cmp.b	#57,d5		; 57=on reoit toutes les lignes
	beq	receive_all_lines
	cmp.b	#58,d5		; 58=nouvelle(s) lignes provenant de l'hote.
	beq	longueur
	cmp.b	#59,d5
	beq	display2	; 59=rien de nouveau et on affiche sa propre ligne
	cmp.b	#60,d5
	beq	init_lines
	;bne	main_loop
	bne 	abort2		; si c autre chose on quitte

init_lines:
	move.w	#13,index
	move.b	#1,line
	WriteStr #1,#13,#4,dot
	bra	display2
	;bra	main_loop

receive_all_lines:
	move.w	#13,index
	move.b	#1,line

	
longueur:
	bsr	rcv
	move.b	d5,d6		;d5=longueur du message  afficher(<40)
	lea     str(PC),a3
message:
	bsr	rcv		; on reoit le message
	tst.b	d5
	beq	abort2
	move.b  d5,(a3)+
	move.w	(tios::kb_vars+$1E),d0
	clr.w	(tios::kb_vars+$1C)
	cmp.w	#264,d0
	beq	abort2
	subq.b	#1,d6
	tst.b	d6
	bne	message
	
	clr.b	(a3)
	lea     str(PC),a3
	lea     0(a3),a4	; on stocke le message...
	bsr	display		; on affiche le message
	move.b	#6,d5		; on previent que c'est afficher
	bsr	send

	bsr	rcv		; on regarde si c'est le dernier message...
	cmp.b	#130,d5
	beq	longueur	; 130=encore un message
	cmp.b	#56,d5		; 56=fin de transmition
	beq	main_loop
	bne	abort2		; il ya une erreur de transmition...
	bra 	main_loop

;************** routines ***************************

display:
	cmp.w	#109,index
	beq	top1
disp1:
	WriteStrA #1,index,#4,a4 ; on affiche la ligne
	add.w	#8,index
	add.b	#1,line
	cmp.w	#109,index
	beq	clean1
	WriteStr #1,index,#4,dot
	rts
top1:
	move.w	#13,index
	move.b	#1,line
	bra	disp1
clean1:
	WriteStr #1,#13,#4,dot
	rts

display2:
	cmp.w	#109,index
	beq	top2
disp2:
	WriteStr #1,index,#4,user
	WriteStrA #37,index,#4,a2 ; on affiche son message
	add.w	#8,index
	add.b	#1,line
	cmp.w	#109,index
	beq	clean2
	WriteStr #1,index,#4,dot
	bra	main_loop
top2:
	move.w	#13,index
	move.b	#1,line
	bra	disp2	
clean2:
	WriteStr #1,#13,#4,dot
	bra	main_loop

init_interrupt:
	move.w		#$0700,d0
	trap		#1
	move.l		$64,level1_int
	bclr.b		#2,$600001
	move.l		#newint#1,$64
	bset.b		#2,$600001
	trap		#1
	rts

close_interrupt:
	move.w		#$0700,d0
	trap		#1
	bclr.b		#2,$600001
	move.l		level1_int,$64
	bset.b		#2,$600001
	trap		#1
	rts

;***INT #1 : interruption effectue 350 fois par secondes environ
newint#1:
 add.w   #1,timer
 rte

show_user:
	move.w	#0,d4 :y
	move.w	#1,d3 :x
	btst.b	#0,d5
	bne	user1
	beq 	suit1
suit1:
	btst.b	#1,d5
	bne	user2
	beq 	suit2
suit2:
	btst.b	#2,d5
	bne	user3
	beq 	suit3
suit3:
	btst.b	#3,d5
	bne	user4
	beq 	suit4	
suit4:
	btst.b	#4,d5
	bne	user5
	beq 	suit5
suit5:
	rts
user1:
	WriteStr d3,d4,#4,nom1
	add.w	#35,d3
	bra	suit1
user2:
	WriteStr d3,d4,#4,nom2
	add.w	#35,d3
	bra	suit2

user3:
	WriteStr d3,d4,#4,nom3
	add.w	#35,d3
	bra	suit3
user4:
	WriteStr d3,d4,#4,nom4
	add.w	#35,d3
	bra	suit4
user5:
	WriteStr d3,d4,#4,nom5
	add.w	#35,d3
	bra	suit5

abort:
	WriteStr #0,#113,#4,con_nok
	move.l	#12,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	jsr flib::idle_loop
	;cmp.w	#264,d0
	bra 	exit_prog
abort2:
	move.l	#12,d1
	move.l	#28,d2
	move.l	#1,d4
	move.l	d5,d0
	jsr	hexlib::put_hex
	bra 	main_loop


rcv:	
	move.w	1000,d3		; UART reception (caractere(8bits)->d5)
time_in:
	btst.b	#3,$60000E	; boucle d'attente d'1 bit de start avec time_out !	
	bne	start
	subq	#1,d3
	tst.w	d3
	bne	time_in
	move.b	#0,d5		; time is out : link error probably
	rts		
start:				; bit de start detect:
	bsr	delay2		; on attend 1.25bit(bit de start+1/4bit D0)
	move.b	#0,d3		; on demarre une boucle de 8 cycles
rcv2:
	btst.b	#3,$60000E	; on lit le bit(dans son premier quart)
	beq	rcv_un		; on stocke le bit nx dans d5
	bne	rcv_zero
rcv_suite:
	bsr	delay1		 on attend la duree d'un bit
	move.b	#1,d4		; on regarde si c le 8ieme...
	add.b	d4,d3
	cmp.b 	#8,d3
	bne	rcv2		; si non on recommence
	rts			; si oui on sort de la routine
	
rcv_zero:			; on stocke un zero dans le bit
	bclr.b	d3,d5		; correspondant de d5
	bra rcv_suite
rcv_un:
	bset.b	d3,d5		; on stocke un 1 dans d5
	bra rcv_suite

send:				; UART emission (caractere(8bits)->d5)
	
	bset.b 	#0,$60000E	; 1 bit de start
	bsr 	delay1
	move.b	#0,d3		; on commence la boucle qui va envoyer
lecture:			; les 8 bits de chaque caractere
	btst.b	d3,d5		; on teste le bit nx
	beq	zero		;le bit est 0 -> Z=1
	bne	un		;le bit est 1 -> Z=0
lect2:	
	move.b	#1,d4
	add.b 	d4,d3
	cmp.b 	#8,d3
	bne	lecture

	bclr.b 	#0,$60000E	; 1 bit de stop
	bsr 	delay1
	
	rts
				
un:	
	bclr.b 	#0,$60000E	; on envoie l'impulsion electrique +5v
	bsr 	delay1		; correspondante
	bra 	lect2
zero:	
	bset.b 	#0,$60000E	; on envoie l'impulsion electrique 0v
	bsr 	delay1		; correspondante
	bra 	lect2

delay1:				; boucle de dure d'un bit
	move.w base1,d1
	bra delay_loop
delay2:		
	move.w base2,d1	; boucle de dure d'un 1.25bit
	bra delay_loop
delay3:		
	move.w base3,d1	; boucle de dure longue
	bra delay_loop
delay_loop:	
	bsr	init_interrupt
\delay:
	cmp.w   timer,d1	; boucle d'attente: minimum=2.857ms(1/350)
 	bgt     \delay
 	clr.w   timer
	bsr	close_interrupt
	rts

screen_put:
	WriteStr #1,#0,#4,titre1
        WriteStr #1,#10,#4,titre2
        rts


exit_prog:
	move.w  hnum,-(a7)			;rends la memoire
 	jsr     tios::HeapFree
 	addq    #2,a7
	clr.w   $75B0     
	jsr 	tios::reset_link
 	rts                     ; Exit the program
OutOfMem:
 	rts

Input:
 jsr     flib::idle_loop
 cmp.w	 #264,d0
 beq     abortxt
 bne 	 txtsuit
abortxt:
 movem.l (a7)+,d0-d3
 bra  	abort
txtsuit:
 cmp.w	 #13,d0
 beq     InputDone
 cmp.w	 #257,d0
 beq     BackSpace
 cmp.w   #256,d0
 bcc     Input		;d0=texte
 move.b  d0,(a1)+	;d1=postion y du texte
 move.w  d0,d2		; d3/d0?=postion x
 move.w  d3,d0		
 bsr     WriteChar
 addq	 #6,d3
 addq	 #1,d4
 cmp.w   d6,d4		; nombre de caracteres maxi
 bne     Input 
 beq 	 InputDone
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a1)
 subq    #6,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 subq    #1,d4
 bra     Input
InputDone:
 clr.b	 (a1)
 movem.l (a7)+,d0-d3
 bra 	suitxt
 
WriteChar:
 movem.l d0-d2/a0,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 jsr     tios::DrawCharXY
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0
 rts

;*********************************************************************************
; Define strings used
titre1 		dc.b    "Network sofware for TI92 (v1.08)",0
titre2  	dc.b    "Run under FARGO II (v0.2.7.1 or later).",0
titre3		dc.b	"Net 1.08",0
request 	dc.b	"Sending request to host...Waiting...   ",0
con_nok 	dc.b	"Connection aborted        [Esc]        ",0
connected	dc.b 	"Host contacted                         ",0
connecting	dc.b 	"Contacting host...        [Esc]        ",0
waiting_	dc.b 	"Waiting for reply         [Esc]        ",0
receiving	dc.b 	"Receiving data from host  [Esc]        ",0
transmitting	dc.b	"Transferring data to host [Esc]        ",0
echec		dc.b	"Connection aborted !      [Esc]         Link error",0
standby		dc.b	"Ready - Enter your text.  [Esc=exit]",0
nom1		dc.b 	"user1",0	; nom de user1
nom2		dc.b 	"user2",0	; nom de user2
nom3		dc.b 	"user3",0	; nom de user3
nom4		dc.b 	"user4",0	; nom de user4
nom5		dc.b 	"user5",0	; nom de user5
user		dc.b	"user :",0	; name of TI92's user : be modified on each calculator !
space		dc.b	"     ",0
space2		dc.b	"                                        ",0
dot		dc.b	"_                                      ",0

timer		dc.w 0
level1_int	dc.l 0
delayvar 	dc.w 0

hptr     dc.l 0
hnum     dc.w 0


; Define word values to hold status
;variables	valeur	vitesse:175bps	45bps	  					delay -> duree d'1bit
base1	dc.w    2	;2		8cycles=22.85ms(45bps)		5263	;  tempo 1bit      5263  -> 22.8ms(45bps)
base2	dc.w	3	;3		10 cycles=28.5ms(5/4*22.85)	5789	;  tempo 1.25bit   5789
base3	dc.w    350	;65535
index	dc.w	13
line	dc.b	1
str     ds.b 	64


_comment:
        dc.b    "Net92. v1.08. 08/98",0

        end